# OsiSpxSolverInterface Class Reference

SoPlex Solver Interface Instantiation of OsiSpxSolverInterface for SoPlex. More...

`#include <OsiSpxSolverInterface.hpp>`

Inheritance diagram for OsiSpxSolverInterface:
[legend]
Collaboration diagram for OsiSpxSolverInterface:
[legend]

List of all members.

## Public Member Functions
virtual void | setObjSense (double s)
| Set objective function sense (1 for min (default), -1 for max,).
virtual void | setColSolution (const double *colsol)
| Set the primal solution column values.
virtual void | setRowPrice (const double *rowprice)
| Set dual solution vector.
Solve methods
virtual void | initialSolve ()
| Solve initial LP relaxation.
virtual void | resolve ()
| Resolve an LP relaxation after problem modification.
virtual void | branchAndBound ()
| Invoke solver's built-in enumeration algorithm.
Parameter set/get methods
The set methods return true if the parameter was set to the given value, false otherwise. There can be various reasons for failure: the given parameter is not applicable for the solver (e.g., refactorization frequency for the volume algorithm), the parameter is not yet implemented for the solver or simply the value of the parameter is out of the range the solver accepts. If a parameter setting call returns false check the details of your solver. The get methods return true if the given parameter is applicable for the solver and is implemented. In this case the value of the parameter is returned in the second argument. Otherwise they return false.
bool | setIntParam (OsiIntParam key, int value)
| Set an integer parameter.
bool | setDblParam (OsiDblParam key, double value)
| Set a double parameter.
bool | getIntParam (OsiIntParam key, int &value) const
| Get an integer parameter.
bool | getDblParam (OsiDblParam key, double &value) const
| Get a double parameter.
bool | getStrParam (OsiStrParam key, std::string &value) const
| Get a string parameter.
void | setTimeLimit (double value)
double | getTimeLimit () const
Methods returning info on how the solution process terminated
virtual bool | isAbandoned () const
| Are there a numerical difficulties?
virtual bool | isProvenOptimal () const
| Is optimality proven?
virtual bool | isProvenPrimalInfeasible () const
| Is primal infeasiblity proven?
virtual bool | isProvenDualInfeasible () const
| Is dual infeasiblity proven?
virtual bool | isDualObjectiveLimitReached () const
| Is the given dual objective limit reached?
virtual bool | isIterationLimitReached () const
| Iteration limit reached?
virtual bool | isTimeLimitReached () const
| Time limit reached?
WarmStart related methods
CoinWarmStart * | getEmptyWarmStart () const
| Get empty warm start object.
virtual CoinWarmStart * | getWarmStart () const
| Get warmstarting information.
virtual bool | setWarmStart (const CoinWarmStart *warmstart)
| Set warmstarting information.
Hotstart related methods (primarily used in strong branching). <br>
The user can create a hotstart (a snapshot) of the optimization process then reoptimize over and over again always starting from there. NOTE: between hotstarted optimizations only bound changes are allowed.
virtual void | markHotStart ()
| Create a hotstart point of the optimization process.
virtual void | solveFromHotStart ()
| Optimize starting from the hotstart.
virtual void | unmarkHotStart ()
| Delete the snapshot.
Methods related to querying the input data
virtual int | getNumCols () const
| Get number of columns.
virtual int | getNumRows () const
| Get number of rows.
virtual int | getNumElements () const
| Get number of nonzero elements.
virtual const double * | getColLower () const
| Get pointer to array[getNumCols()] of column lower bounds.
virtual const double * | getColUpper () const
| Get pointer to array[getNumCols()] of column upper bounds.
virtual const char * | getRowSense () const
| Get pointer to array[getNumRows()] of row constraint senses.
virtual const double * | getRightHandSide () const
| Get pointer to array[getNumRows()] of rows right-hand sides.
virtual const double * | getRowRange () const
| Get pointer to array[getNumRows()] of row ranges.
virtual const double * | getRowLower () const
| Get pointer to array[getNumRows()] of row lower bounds.
virtual const double * | getRowUpper () const
| Get pointer to array[getNumRows()] of row upper bounds.
virtual const double * | getObjCoefficients () const
| Get pointer to array[getNumCols()] of objective function coefficients.
virtual double | getObjSense () const
| Get objective function sense (1 for min (default), -1 for max).
virtual bool | isContinuous (int colNumber) const
| Return true if column is continuous.
virtual const CoinPackedMatrix * | getMatrixByRow () const
| Get pointer to row-wise copy of matrix.
virtual const CoinPackedMatrix * | getMatrixByCol () const
| Get pointer to column-wise copy of matrix.
virtual double | getInfinity () const
| Get solver's value for infinity.
Methods related to querying the solution
virtual const double * | getColSolution () const
| Get pointer to array[getNumCols()] of primal solution vector.
virtual const double * | getRowPrice () const
| Get pointer to array[getNumRows()] of dual prices.
virtual const double * | getReducedCost () const
| Get a pointer to array[getNumCols()] of reduced costs.
virtual const double * | getRowActivity () const
| Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.
virtual double | getObjValue () const
| Get objective function value.
virtual int | getIterationCount () const
| Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.
virtual std::vector< double * > | getDualRays (int maxNumRays, bool fullRay=false) const
| Get as many dual rays as the solver can provide.
virtual std::vector< double * > | getPrimalRays (int maxNumRays) const
| Get as many primal rays as the solver can provide.
Changing bounds on variables and constraints
virtual void | setObjCoeff (int elementIndex, double elementValue)
| Set an objective function coefficient.
virtual void | setColLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -COIN_DBL_MAX for -infinity.
virtual void | setColUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use COIN_DBL_MAX for infinity.
virtual void | setColBounds (int elementIndex, double lower, double upper)
| Set a single column lower and upper bound The default implementation just invokes `setColLower` and `setColUpper`.
virtual void | setRowLower (int elementIndex, double elementValue)
| Set a single row lower bound Use -COIN_DBL_MAX for -infinity.
virtual void | setRowUpper (int elementIndex, double elementValue)
| Set a single row upper bound Use COIN_DBL_MAX for infinity.
virtual void | setRowBounds (int elementIndex, double lower, double upper)
| Set a single row lower and upper bound The default implementation just invokes `setRowUower` and `setRowUpper`.
virtual void | setRowType (int index, char sense, double rightHandSide, double range)
| Set the type of a single row .
Integrality related changing methods
virtual void | setContinuous (int index)
| Set the index-th variable to be a continuous variable.
virtual void | setInteger (int index)
| Set the index-th variable to be an integer variable.
Methods to expand a problem.<br>
Note that if a column is added then by default it will correspond to a continuous variable.
virtual void | addCol (const CoinPackedVectorBase &vec, const double collb, const double colub, const double obj)
| Add a column (primal variable) to the problem.
virtual void | deleteCols (const int num, const int *colIndices)
| Remove a set of columns (primal variables) from the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const double rowlb, const double rowub)
| Add a row (constraint) to the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const char rowsen, const double rowrhs, const double rowrng)
| Add a row (constraint) to the problem.
virtual void | deleteRows (const int num, const int *rowIndices)
| Delete a set of rows (constraints) from the problem.
Methods to input a problem
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, double *&rowlb, double *&rowub)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, char *&rowsen, double *&rowrhs, double *&rowrng)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual int | readMps (const char *filename, const char *extension="mps")
| Read an mps file from the given filename.
virtual void | writeMps (const char *filename, const char *extension="mps", double objSense=0.0) const
| Write the problem into an mps file of the given filename.
Constructors and destructor
| OsiSpxSolverInterface ()
| Default Constructor.
virtual OsiSolverInterface * | clone (bool copyData=true) const
| Clone.
| OsiSpxSolverInterface (const OsiSpxSolverInterface &)
| Copy constructor.
OsiSpxSolverInterface & | operator= (const OsiSpxSolverInterface &rhs)
| Assignment operator.
virtual | ~OsiSpxSolverInterface ()
| Destructor.
## Protected Member Functions
Protected methods
virtual void | applyRowCut (const OsiRowCut &rc)
| Apply a row cut. Return true if cut was applied.
virtual void | applyColCut (const OsiColCut &cc)
| Apply a column cut (bound adjustment).
## Protected Attributes
Protected member data
soplex::SoPlex * | soplex_
| SoPlex solver object.
## Private Attributes
Private member data
soplex::DIdxSet * | spxintvars_
| indices of integer variables
void * | hotStartCStat_
| Hotstart information.
int | hotStartCStatSize_
| indices of integer variables
void * | hotStartRStat_
| indices of integer variables
int | hotStartRStatSize_
| indices of integer variables
int | hotStartMaxIteration_
| indices of integer variables
Cached information derived from the SoPlex model
soplex::DVector * | obj_
| Pointer to objective Vector.
char * | rowsense_
| Pointer to dense vector of row sense indicators.
double * | rhs_
| Pointer to dense vector of row right-hand side values.
double * | rowrange_
| Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).
soplex::DVector * | colsol_
| Pointer to primal solution vector.
soplex::DVector * | rowsol_
| Pointer to dual solution vector.
soplex::DVector * | redcost_
| Pointer to reduced cost vector.
soplex::DVector * | rowact_
| Pointer to row activity (slack) vector.
CoinPackedMatrix * | matrixByRow_
| Pointer to row-wise copy of problem matrix coefficients.
CoinPackedMatrix * | matrixByCol_
| Pointer to row-wise copy of problem matrix coefficients.
## Friends
void | OsiSpxSolverInterfaceUnitTest (const std::string &mpsDir, const std::string &netlibDir)
| A function that tests the methods in the OsiSpxSolverInterface class.
## Private methods
enum | keepCachedFlag { KEEPCACHED_NONE = 0, KEEPCACHED_COLUMN = 1, KEEPCACHED_ROW = 2, KEEPCACHED_MATRIX = 4, KEEPCACHED_RESULTS = 8, KEEPCACHED_PROBLEM = KEEPCACHED_COLUMN | KEEPCACHED_ROW | KEEPCACHED_MATRIX, KEEPCACHED_ALL = KEEPCACHED_PROBLEM | KEEPCACHED_RESULTS, FREECACHED_COLUMN = KEEPCACHED_PROBLEM & ~KEEPCACHED_COLUMN, FREECACHED_ROW = KEEPCACHED_PROBLEM & ~KEEPCACHED_ROW, FREECACHED_MATRIX = KEEPCACHED_PROBLEM & ~KEEPCACHED_MATRIX, FREECACHED_RESULTS = KEEPCACHED_ALL & ~KEEPCACHED_RESULTS }
| free cached column rim vectors More...
void | freeCachedColRim ()
| free cached column rim vectors
void | freeCachedRowRim ()
| free cached row rim vectors
void | freeCachedResults ()
| free cached result vectors
void | freeCachedMatrix ()
| free cached matrices
void | freeCachedData (int keepCached=KEEPCACHED_NONE)
| free all cached data (except specified entries, see getLpPtr())
void | freeAllMemory ()
| free all allocated memory

## Detailed Description

SoPlex Solver Interface Instantiation of OsiSpxSolverInterface for SoPlex.

Definition at line 32 of file OsiSpxSolverInterface.hpp.

## Member Enumeration Documentation

enum OsiSpxSolverInterface::keepCachedFlag`[private]`

free cached column rim vectors

Enumerator:

  KEEPCACHED_NONE | discard all cached data (default)
  KEEPCACHED_COLUMN | column information: objective values, lower and upper bounds, variable types
  KEEPCACHED_ROW | row information: right hand sides, ranges and senses, lower and upper bounds for row
  KEEPCACHED_MATRIX | problem matrix: matrix ordered by column and by row
  KEEPCACHED_RESULTS | LP solution: primal and dual solution, reduced costs, row activities.
  KEEPCACHED_PROBLEM | only discard cached LP solution
  KEEPCACHED_ALL | keep all cached data (similar to getMutableLpPtr())
  FREECACHED_COLUMN | free only cached column and LP solution information
  FREECACHED_ROW | free only cached row and LP solution information
  FREECACHED_MATRIX | free only cached matrix and LP solution information
  FREECACHED_RESULTS | free only cached LP solution information

Definition at line 648 of file OsiSpxSolverInterface.hpp.

## Constructor & Destructor Documentation

OsiSpxSolverInterface::OsiSpxSolverInterface | ( |  | ) |

Default Constructor.

OsiSpxSolverInterface::OsiSpxSolverInterface | ( | const OsiSpxSolverInterface & |  | ) |

Copy constructor.

virtual OsiSpxSolverInterface::~OsiSpxSolverInterface | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual void OsiSpxSolverInterface::initialSolve | ( |  | ) | `[virtual]`

Solve initial LP relaxation.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::resolve | ( |  | ) | `[virtual]`

Resolve an LP relaxation after problem modification.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::branchAndBound | ( |  | ) | `[virtual]`

Invoke solver's built-in enumeration algorithm.

Implements OsiSolverInterface.

bool OsiSpxSolverInterface::setIntParam | ( | OsiIntParam | key,
|  | int | value |
| ) |  |  | `[virtual]`

Set an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiSpxSolverInterface::setDblParam | ( | OsiDblParam | key,
|  | double | value |
| ) |  |  | `[virtual]`

Set a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiSpxSolverInterface::getIntParam | ( | OsiIntParam | key,
|  | int & | value |
| ) |  |  | const`[virtual]`

Get an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiSpxSolverInterface::getDblParam | ( | OsiDblParam | key,
|  | double & | value |
| ) |  |  | const`[virtual]`

Get a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiSpxSolverInterface::getStrParam | ( | OsiStrParam | key,
|  | std::string & | value |
| ) |  |  | const`[virtual]`

Get a string parameter.

Reimplemented from OsiSolverInterface.

void OsiSpxSolverInterface::setTimeLimit | ( | double | value | ) |

double OsiSpxSolverInterface::getTimeLimit | ( |  | ) | const

virtual bool OsiSpxSolverInterface::isAbandoned | ( |  | ) | const`[virtual]`

Are there a numerical difficulties?

Implements OsiSolverInterface.

virtual bool OsiSpxSolverInterface::isProvenOptimal | ( |  | ) | const`[virtual]`

Is optimality proven?

Implements OsiSolverInterface.

virtual bool OsiSpxSolverInterface::isProvenPrimalInfeasible | ( |  | ) | const`[virtual]`

Is primal infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiSpxSolverInterface::isProvenDualInfeasible | ( |  | ) | const`[virtual]`

Is dual infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiSpxSolverInterface::isDualObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given dual objective limit reached?

Reimplemented from OsiSolverInterface.

virtual bool OsiSpxSolverInterface::isIterationLimitReached | ( |  | ) | const`[virtual]`

Iteration limit reached?

Implements OsiSolverInterface.

virtual bool OsiSpxSolverInterface::isTimeLimitReached | ( |  | ) | const`[virtual]`

Time limit reached?

CoinWarmStart* OsiSpxSolverInterface::getEmptyWarmStart | ( |  | ) | const`[inline, virtual]`

Get empty warm start object.

Implements OsiSolverInterface.

Definition at line 106 of file OsiSpxSolverInterface.hpp.

virtual CoinWarmStart* OsiSpxSolverInterface::getWarmStart | ( |  | ) | const`[virtual]`

Get warmstarting information.

Implements OsiSolverInterface.

virtual bool OsiSpxSolverInterface::setWarmStart | ( | const CoinWarmStart * | warmstart | ) | `[virtual]`

Set warmstarting information.

Return true/false depending on whether the warmstart information was accepted or not.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::markHotStart | ( |  | ) | `[virtual]`

Create a hotstart point of the optimization process.

Reimplemented from OsiSolverInterface.

virtual void OsiSpxSolverInterface::solveFromHotStart | ( |  | ) | `[virtual]`

Optimize starting from the hotstart.

Reimplemented from OsiSolverInterface.

virtual void OsiSpxSolverInterface::unmarkHotStart | ( |  | ) | `[virtual]`

Delete the snapshot.

Reimplemented from OsiSolverInterface.

virtual int OsiSpxSolverInterface::getNumCols | ( |  | ) | const`[virtual]`

Get number of columns.

Implements OsiSolverInterface.

virtual int OsiSpxSolverInterface::getNumRows | ( |  | ) | const`[virtual]`

Get number of rows.

Implements OsiSolverInterface.

virtual int OsiSpxSolverInterface::getNumElements | ( |  | ) | const`[virtual]`

Get number of nonzero elements.

Implements OsiSolverInterface.

virtual const double* OsiSpxSolverInterface::getColLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiSpxSolverInterface::getColUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column upper bounds.

Implements OsiSolverInterface.

virtual const char* OsiSpxSolverInterface::getRowSense | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row constraint senses.

- 'L': <= constraint
- 'E': = constraint
- 'G': >= constraint
- 'R': ranged constraint
- 'N': free constraint

Implements OsiSolverInterface.

virtual const double* OsiSpxSolverInterface::getRightHandSide | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of rows right-hand sides.

- if rowsense()[i] == 'L' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'G' then rhs()[i] == rowlower()[i]
- if rowsense()[i] == 'R' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'N' then rhs()[i] == 0.0

Implements OsiSolverInterface.

virtual const double* OsiSpxSolverInterface::getRowRange | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row ranges.

- if rowsense()[i] == 'R' then rowrange()[i] == rowupper()[i] - rowlower()[i]
- if rowsense()[i] != 'R' then rowrange()[i] is 0.0

Implements OsiSolverInterface.

virtual const double* OsiSpxSolverInterface::getRowLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiSpxSolverInterface::getRowUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row upper bounds.

Implements OsiSolverInterface.

virtual const double* OsiSpxSolverInterface::getObjCoefficients | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of objective function coefficients.

Implements OsiSolverInterface.

virtual double OsiSpxSolverInterface::getObjSense | ( |  | ) | const`[virtual]`

Get objective function sense (1 for min (default), -1 for max).

Implements OsiSolverInterface.

virtual bool OsiSpxSolverInterface::isContinuous | ( | int | colNumber | ) | const`[virtual]`

Return true if column is continuous.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiSpxSolverInterface::getMatrixByRow | ( |  | ) | const`[virtual]`

Get pointer to row-wise copy of matrix.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiSpxSolverInterface::getMatrixByCol | ( |  | ) | const`[virtual]`

Get pointer to column-wise copy of matrix.

Implements OsiSolverInterface.

virtual double OsiSpxSolverInterface::getInfinity | ( |  | ) | const`[virtual]`

Get solver's value for infinity.

Implements OsiSolverInterface.

virtual const double* OsiSpxSolverInterface::getColSolution | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of primal solution vector.

Implements OsiSolverInterface.

virtual const double* OsiSpxSolverInterface::getRowPrice | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of dual prices.

Implements OsiSolverInterface.

virtual const double* OsiSpxSolverInterface::getReducedCost | ( |  | ) | const`[virtual]`

Get a pointer to array[getNumCols()] of reduced costs.

Implements OsiSolverInterface.

virtual const double* OsiSpxSolverInterface::getRowActivity | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.

Implements OsiSolverInterface.

virtual double OsiSpxSolverInterface::getObjValue | ( |  | ) | const`[virtual]`

Get objective function value.

Implements OsiSolverInterface.

virtual int OsiSpxSolverInterface::getIterationCount | ( |  | ) | const`[virtual]`

Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.

Implements OsiSolverInterface.

virtual std::vector<double*> OsiSpxSolverInterface::getDualRays | ( | int | maxNumRays,
|  | bool | fullRay = `false` |
| ) |  |  | const`[virtual]`

Get as many dual rays as the solver can provide.

(In case of proven primal infeasibility there should be at least one.)

The first getNumRows() ray components will always be associated with the row duals (as returned by getRowPrice()). If `fullRay` is true, the final getNumCols() entries will correspond to the ray components associated with the nonbasic variables. If the full ray is requested and the method cannot provide it, it will throw an exception.

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumRows() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual std::vector<double*> OsiSpxSolverInterface::getPrimalRays | ( | int | maxNumRays | ) | const`[virtual]`

Get as many primal rays as the solver can provide.

(In case of proven dual infeasibility there should be at least one.)

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumCols() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::setObjCoeff | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set an objective function coefficient.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::setColLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column lower bound
Use -COIN_DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::setColUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column upper bound
Use COIN_DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::setColBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[virtual]`

Set a single column lower and upper bound
The default implementation just invokes `setColLower` and `setColUpper`.

Reimplemented from OsiSolverInterface.

virtual void OsiSpxSolverInterface::setRowLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row lower bound
Use -COIN_DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::setRowUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row upper bound
Use COIN_DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::setRowBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[virtual]`

Set a single row lower and upper bound
The default implementation just invokes `setRowUower` and `setRowUpper`.

Reimplemented from OsiSolverInterface.

virtual void OsiSpxSolverInterface::setRowType | ( | int | index,
|  | char | sense,
|  | double | rightHandSide,
|  | double | range |
| ) |  |  | `[virtual]`

Set the type of a single row
.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::setContinuous | ( | int | index | ) | `[virtual]`

Set the index-th variable to be a continuous variable.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::setInteger | ( | int | index | ) | `[virtual]`

Set the index-th variable to be an integer variable.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::setObjSense | ( | double | s | ) | `[virtual]`

Set objective function sense (1 for min (default), -1 for max,).

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::setColSolution | ( | const double * | colsol | ) | `[virtual]`

Set the primal solution column values.

colsol[numcols()] is an array of values of the problem column variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of colsol() until changed by another call to setColsol() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::setRowPrice | ( | const double * | rowprice | ) | `[virtual]`

Set dual solution vector.

rowprice[numrows()] is an array of values of the problem row dual variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of rowprice() until changed by another call to setRowprice() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::addCol | ( | const CoinPackedVectorBase & | vec,
|  | const double | collb,
|  | const double | colub,
|  | const double | obj |
| ) |  |  | `[virtual]`

Add a column (primal variable) to the problem.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::deleteCols | ( | const int | num,
|  | const int * | colIndices |
| ) |  |  | `[virtual]`

Remove a set of columns (primal variables) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted variables are nonbasic.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const double | rowlb,
|  | const double | rowub |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const char | rowsen,
|  | const double | rowrhs,
|  | const double | rowrng |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::deleteRows | ( | const int | num,
|  | const int * | rowIndices |
| ) |  |  | `[virtual]`

Delete a set of rows (constraints) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted rows are loose.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `rowub`: all rows have upper bound infinity
- `rowlb`: all rows have lower bound -infinity
- `obj`: all variables have 0 objective coefficient

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | double *& | rowlb,
|  | double *& | rowub |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `obj`: all variables have 0 objective coefficient
- `rowsen`: all rows are >=
- `rowrhs`: all right hand sides are 0
- `rowrng`: 0 for the ranged rows

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | char *& | rowsen,
|  | double *& | rowrhs,
|  | double *& | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual int OsiSpxSolverInterface::readMps | ( | const char * | filename,
|  | const char * | extension = `"mps"` |
| ) |  |  | `[virtual]`

Read an mps file from the given filename.

Reimplemented from OsiSolverInterface.

virtual void OsiSpxSolverInterface::writeMps | ( | const char * | filename,
|  | const char * | extension = `"mps"`,
|  | double | objSense = `0.0` |
| ) |  |  | const`[virtual]`

Write the problem into an mps file of the given filename.

If objSense is non zero then -1.0 forces the code to write a maximization objective and +1.0 to write a minimization one. If 0.0 then solver can do what it wants

Implements OsiSolverInterface.

virtual OsiSolverInterface* OsiSpxSolverInterface::clone | ( | bool | copyData = `true` | ) | const`[virtual]`

Clone.

Implements OsiSolverInterface.

OsiSpxSolverInterface& OsiSpxSolverInterface::operator= | ( | const OsiSpxSolverInterface & | rhs | ) |

Assignment operator.

Reimplemented from OsiSolverInterface.

virtual void OsiSpxSolverInterface::applyRowCut | ( | const OsiRowCut & | rc | ) | `[protected, virtual]`

Apply a row cut. Return true if cut was applied.

Implements OsiSolverInterface.

virtual void OsiSpxSolverInterface::applyColCut | ( | const OsiColCut & | cc | ) | `[protected, virtual]`

Apply a column cut (bound adjustment).

Return true if cut was applied.

Implements OsiSolverInterface.

void OsiSpxSolverInterface::freeCachedColRim | ( |  | ) | `[private]`

free cached column rim vectors

void OsiSpxSolverInterface::freeCachedRowRim | ( |  | ) | `[private]`

free cached row rim vectors

void OsiSpxSolverInterface::freeCachedResults | ( |  | ) | `[private]`

free cached result vectors

void OsiSpxSolverInterface::freeCachedMatrix | ( |  | ) | `[private]`

free cached matrices

void OsiSpxSolverInterface::freeCachedData | ( | int | keepCached = `KEEPCACHED_NONE` | ) | `[private]`

free all cached data (except specified entries, see getLpPtr())

void OsiSpxSolverInterface::freeAllMemory | ( |  | ) | `[private]`

free all allocated memory

## Friends And Related Function Documentation

void OsiSpxSolverInterfaceUnitTest | ( | const std::string & | mpsDir,
|  | const std::string & | netlibDir |
| ) |  |  | `[friend]`

A function that tests the methods in the OsiSpxSolverInterface class.

## Member Data Documentation

soplex::SoPlex* OsiSpxSolverInterface::soplex_`[protected]`

SoPlex solver object.

Definition at line 628 of file OsiSpxSolverInterface.hpp.

soplex::DIdxSet* OsiSpxSolverInterface::spxintvars_`[private]`

indices of integer variables

Definition at line 685 of file OsiSpxSolverInterface.hpp.

void* OsiSpxSolverInterface::hotStartCStat_`[private]`

Hotstart information.

Definition at line 688 of file OsiSpxSolverInterface.hpp.

int OsiSpxSolverInterface::hotStartCStatSize_`[private]`

indices of integer variables

Definition at line 689 of file OsiSpxSolverInterface.hpp.

void* OsiSpxSolverInterface::hotStartRStat_`[private]`

indices of integer variables

Definition at line 690 of file OsiSpxSolverInterface.hpp.

int OsiSpxSolverInterface::hotStartRStatSize_`[private]`

indices of integer variables

Definition at line 691 of file OsiSpxSolverInterface.hpp.

int OsiSpxSolverInterface::hotStartMaxIteration_`[private]`

indices of integer variables

Definition at line 692 of file OsiSpxSolverInterface.hpp.

soplex::DVector* OsiSpxSolverInterface::obj_`[mutable, private]`

Pointer to objective Vector.

Definition at line 697 of file OsiSpxSolverInterface.hpp.

char* OsiSpxSolverInterface::rowsense_`[mutable, private]`

Pointer to dense vector of row sense indicators.

Definition at line 700 of file OsiSpxSolverInterface.hpp.

double* OsiSpxSolverInterface::rhs_`[mutable, private]`

Pointer to dense vector of row right-hand side values.

Definition at line 703 of file OsiSpxSolverInterface.hpp.

double* OsiSpxSolverInterface::rowrange_`[mutable, private]`

Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).

Definition at line 706 of file OsiSpxSolverInterface.hpp.

soplex::DVector* OsiSpxSolverInterface::colsol_`[mutable, private]`

Pointer to primal solution vector.

Definition at line 709 of file OsiSpxSolverInterface.hpp.

soplex::DVector* OsiSpxSolverInterface::rowsol_`[mutable, private]`

Pointer to dual solution vector.

Definition at line 712 of file OsiSpxSolverInterface.hpp.

soplex::DVector* OsiSpxSolverInterface::redcost_`[mutable, private]`

Pointer to reduced cost vector.

Definition at line 715 of file OsiSpxSolverInterface.hpp.

soplex::DVector* OsiSpxSolverInterface::rowact_`[mutable, private]`

Pointer to row activity (slack) vector.

Definition at line 718 of file OsiSpxSolverInterface.hpp.

CoinPackedMatrix* OsiSpxSolverInterface::matrixByRow_`[mutable, private]`

Pointer to row-wise copy of problem matrix coefficients.

Definition at line 721 of file OsiSpxSolverInterface.hpp.

CoinPackedMatrix* OsiSpxSolverInterface::matrixByCol_`[mutable, private]`

Pointer to row-wise copy of problem matrix coefficients.

Definition at line 724 of file OsiSpxSolverInterface.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Blis-0.93.2/Osi/src/OsiSpx/OsiSpxSolverInterface.hpp